<?php
// $Id: views_plugin_row_mediarss.inc,v 1.2 2008/12/16 17:38:38 microbe Exp $
/**
 * @file
 * Contains the Meida RSS row plugin.
 */

/**
 * Media RSS row plugin to render an RSS feed.
 *
 */

class views_plugin_row_mediarss extends views_plugin_row {
function option_definition() {
    $options = parent::option_definition();

    $options['item_length'] = array('default' => 'default');
    $options['item_picture_size'] = array('default' => 'preview');
    return $options;
  }

  function options_form(&$form, &$form_state) {
    $form['item_length'] = array(
      '#type' => 'select',
      '#title' => t('Display type'),
      '#options' => array(
        'fulltext' => t('Full text'),
        'teaser' => t('Title plus teaser'),
        'title' => t('Title only'),
        'fulltextpic' => t('Full text plus pic'),
	  'teaserpic' => t('Title plus picture plus teaser'),
	  'titlepic' => t('Title plus picture'),
        'default' => t('Use default RSS settings'),
      ),
      '#default_value' => $this->options['item_length'],
    );

  $nodetypes = node_get_types();
  foreach ($nodetypes as $nodetype) {
$nodetypes2[$nodetype->type]=$nodetype->name;
}
$form['mediarss_typename'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Node types to convert'),
    '#options' => $nodetypes2,
    '#default_value' => $this->options['mediarss_typename'],
    '#description' => t("The content types you want images to be displayed for."),
    '#required' => TRUE,
  );
if(module_exists('imagefield') && module_exists('imagecache')){
$cckimagefields =db_query("SELECT * FROM {content_node_field} WHERE type='image'");
$cckimagefieldsarray=array();
while ($cckimagefield = db_fetch_array($cckimagefields)){
$cckimagefieldsarray[$cckimagefield['field_name']]=$cckimagefield['field_name'];
}
  $form['mediarss_imgfield'] = array(
    '#type' => 'checkboxes',
    '#title' => t('CCK ImageField'),
    '#options' => $cckimagefieldsarray,
    '#default_value' => $this->options['mediarss_imgfield'],
    '#description' => t("The field name you assigned to the CCK ImageField you wish to display."),
    '#required' => TRUE,
  );
$imagecachepresets= array();
  foreach (imagecache_presets() as $preset) {
    $imagecachepresets[$preset['presetname']] =$preset['presetname'];
  }
  $form['mediarss_cachepreset'] = array(
    '#type' => 'select',
    '#title' => t('ImageCache Preset'),
    '#options' => $imagecachepresets,
    '#default_value' => $this->options['mediarss_cachepreset'],
    '#description' => t("The name of the ImageCache preset you want to use to display the images."),
    '#required' => TRUE,
  );
}
if(module_exists('image')){
    $form['item_picture_size'] = array(
      '#type' => 'select',
      '#title' => t('Image Module Picture Size'),
      '#options' => array(
        'preview' => t('Preview'),
        'thumbnail' => t('Thumbnail'),
        '_original' => t('Original'),
      ),
      '#default_value' => $this->options['item_picture_size'],
    );
}
  }


  function render($row) {
    // For the most part, this code is taken from node_feed() in node.module
    global $base_url;

    $item_length = $this->options['item_length'];
    
    if ($item_length == 'default') {
      $item_length = variable_get('feed_item_length', 'teaser');
    }

    if (empty($this->view->style_plugin->namespaces)) {
      $this->view->style_plugin->namespaces['xmlns:dc'] = 'http://purl.org/dc/elements/1.1/';
    }
    $this->view->style_plugin->namespaces['xmlns:media'] = 'http://search.yahoo.com/mrss/';
    // Load the specified node:
    $item = node_load($row->nid);
    $item->build_mode = NODE_BUILD_RSS;
    $item->link = url("node/$row->nid", array('absolute' => TRUE));

    if ($item_length != 'title') {
      $teaser = ($item_length == 'teaser') ? TRUE : FALSE;

      // Filter and prepare node teaser
      if (node_hook($item, 'view')) {
        $item = node_invoke($item, 'view', $teaser, FALSE);
      }
      else {
        $item = node_prepare($item, $teaser);
      }

      // Allow modules to change $node->teaser before viewing.
      node_invoke_nodeapi($item, 'view', $teaser, FALSE);
    }

    // Allow modules to add additional item fields and/or modify $item
    $extra = node_invoke_nodeapi($item, 'rss item');
    $extra = array_merge($extra,
      array(
        array('key' => 'pubDate', 'value' => gmdate('r', $item->created)),
        array('key' => 'dc:creator', 'value' => $item->name),
        array(
          'key' => 'guid',
          'value' => $item->nid . ' at ' . $base_url,
          'attributes' => array('isPermaLink' => 'false')
        ),
      )
    );
$item_picture_size = $this->options['item_picture_size'];


$imagefields = $this->options['mediarss_imgfield'];
foreach($this->options['mediarss_typename'] as $mediarsstype){
//$item->teaser.=$mediarsstype.' ';
if($item->type==$mediarsstype && $mediarsstype!='0' && $mediarsstype=='image' && module_exists('image')){
	   //$item->teaser.="image-loop ";
	   $attributes['url'] =  file_create_url($item->images[IMAGE_ORIGINAL]);
         $media['url'] = $attributes['url'];
         $media['type'] = file_get_mimetype($item->images[IMAGE_ORIGINAL]);
 $extra = array_merge($extra,
array(
        array('key' => 'media:content', 'attributes' => $media),
        array('key' => 'media:thumbnail', 'attributes' => $attributes),
      )
    );
$picture_text = l(image_display($item, $item_picture_size), 'node/'. $item->nid, array('html' => TRUE));
 $media=array();
$attributes=array();

}
if(module_exists('imagefield') && $item->type==$mediarsstype){
	//$item->teaser.="imagefield-type ";
		foreach($imagefields as $imagefield){
			if($item->{$imagefield}[0]['filepath']!='0'){
	                  //$item->teaser.="imagefield-loop ";
				$imagecache = $this->options['mediarss_cachepreset'];
				$picture_text = l(theme('imagecache', $imagecache, $item->{$imagefield}[0]['filepath']), url("node/".$item->nid), array('html' => TRUE));
				$attributes['url'] =  file_create_url($item->{$imagefield}[0]['filepath']);
				$media['url'] = $attributes['url'];
				$media['type'] = file_get_mimetype($item->{$imagefield}[0]['filepath']);
				$extra = array_merge($extra,
					array(
						array('key' => 'media:content', 'attributes' => $media),
						array('key' => 'media:thumbnail', 'attributes' => $attributes),
					)
				);
			}
		}			
	}	
}
    foreach ($extra as $element) {
      if (isset($element['namespace'])) {
        $this->view->style_plugin->namespaces = array_merge($this->view->style_plugin->namespaces, $element['namespace']);
      }
    }

    // Prepare the item description
    switch ($item_length) {
      case 'fulltext':
        $item_text = $item->body;
        break;
      case 'teaser':
        $item_text = $item->teaser;
        if (!empty($item->readmore)) {
          $item_text .= '<p>' . l(t('read more'), 'node/' . $item->nid, array('absolute' => TRUE, 'attributes' => array('target' => '_blank'))) . '</p>';
        }
        break;
      case 'title':
        $item_text = '';
        break;
      case 'fulltextpic':
        $item_text = $picture_text.$item->body;
        break;
      case 'teaserpic':
        $item_text = $picture_text.$item->teaser;
        if (!empty($item->readmore)) {
          $item_text .= '<p>' . l(t('read more'), 'node/' . $item->nid, array('absolute' => TRUE, 'attributes' => array('target' => '_blank'))) . '</p>';
        }
        break;
      case 'titlepic':
        $item_text = $picture_text;
        break;
    }

    return format_rss_item($item->title, $item->link, $item_text, $extra);
  }

}